#ifndef _FTL_SMOOTHING_HPP_
#define _FTL_SMOOTHING_HPP_

#include <ftl/filters/filter.hpp>

namespace ftl {
namespace filters {

class DepthSmoother : public ftl::Filter {
    public:
    explicit DepthSmoother(nlohmann::json &config);
    ~DepthSmoother();

    void filter(ftl::rgbd::Frame &frame, ftl::rgbd::Source *src, cudaStream_t stream) override;

    private:
    cv::cuda::GpuMat temp_;
    ftl::rgbd::Frame frames_[4];
};

class MLSSmoother : public ftl::Filter {
    public:
    explicit MLSSmoother(nlohmann::json &config);
    ~MLSSmoother();

    void filter(ftl::rgbd::Frame &frame, ftl::rgbd::Source *src, cudaStream_t stream) override;

    private:
};

}
}

#endif  // _FTL_SMOOTHING_HPP_
