#include <ftl/filters/colours.hpp>

using ftl::filters::ColourChannels;
using ftl::codecs::Channel;

ColourChannels::ColourChannels(nlohmann::json &config) : ftl::Filter(config) {

}

ColourChannels::~ColourChannels() {

}

void ColourChannels::filter(ftl::rgbd::Frame &f, ftl::rgbd::Source *s, cudaStream_t stream) {
	// Convert colour from BGR to BGRA if needed
	if (f.get<cv::cuda::GpuMat>(Channel::Colour).type() == CV_8UC3) {
		//cv::cuda::Stream cvstream = cv::cuda::StreamAccessor::wrapStream(stream);
		// Convert to 4 channel colour
		auto &col = f.get<cv::cuda::GpuMat>(Channel::Colour);
		temp_.create(col.size(), CV_8UC4);
		cv::cuda::swap(col, temp_);
		cv::cuda::cvtColor(temp_,col, cv::COLOR_BGR2BGRA, 0);
	}
}
