#include <ftl/filters/filter.hpp>

using ftl::Filter;
using ftl::Filters;

Filter::Filter(nlohmann::json &config) : ftl::Configurable(config) {
	enabled_ = value("enabled", true);

	on("enabled", [this](const ftl::config::Event &e) {
		enabled_ = value("enabled", true);
	});
}

Filter::~Filter() {}

Filters::Filters(nlohmann::json &config) : ftl::Configurable(config) {

}

Filters::~Filters() {

}

void Filters::filter(ftl::rgbd::Frame &f, ftl::rgbd::Source *s, cudaStream_t stream) {
	for (auto i : filters_) {
		if (i->enabled()) {
			i->filter(f, s, stream);
		}
	}
}

Filter *Filters::_create(Filter *f) {
	filters_.push_back(f);
	return f;
}
